Index: meson.build
===================================================================
--- meson.build	(revision de96d3bfc2010ce18fdf8d42328d4c461d7ca3f2)
+++ meson.build	(revision 00e62883ce36dafecb81ee65875c0b6a4529130b)
@@ -72,4 +72,10 @@
 install_files = []
 install_deps = []
+
+# Exported libraries and include files
+# Format: [ type, source_file, destination ]
+# See meson/part/exports/copy-export.sh for supported file types.
+exported_devel_files = []
+
 # Install script for headers.
 # TODO: Make a list of directories and turn into script later.
Index: meson/part/exports/copy-export.sh
===================================================================
--- meson/part/exports/copy-export.sh	(revision 00e62883ce36dafecb81ee65875c0b6a4529130b)
+++ meson/part/exports/copy-export.sh	(revision 00e62883ce36dafecb81ee65875c0b6a4529130b)
@@ -0,0 +1,65 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2024 Vojtech Horky
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+set -ue
+
+target_dir="${DESTDIR:-export-dev}"
+
+rm -rf "${target_dir:?}/lib"
+rm -rf "${target_dir}/include"
+
+mkdir -p "${target_dir}/lib"
+mkdir -p "${target_dir}/include"
+
+
+while [ "$#" -gt 0 ]; do
+    case "$1" in
+        staticlib)
+            ar -t "$2" | xargs ar crs "${target_dir}/lib/$3"
+            ;;
+        include)
+            mkdir -p "${target_dir}/include/$3"
+            cp -r -L -t "${target_dir}/include/$3" "$2"/*
+            ;;
+        includesymlink)
+            (
+                cd "${target_dir}/include/$3" && ln -s "../$2" .
+            )
+            ;;
+        config)
+            cp -L "$2" "${target_dir}/$3"
+            ;;
+        *)
+            echo "Unknown type $1, aborting." >&2
+            exit 1
+            ;;
+    esac
+    shift 3
+done
Index: meson/part/exports/meson.build
===================================================================
--- meson/part/exports/meson.build	(revision de96d3bfc2010ce18fdf8d42328d4c461d7ca3f2)
+++ meson/part/exports/meson.build	(revision 00e62883ce36dafecb81ee65875c0b6a4529130b)
@@ -85,2 +85,12 @@
 	capture: true,
 )
+
+run_target('export-dev',
+    command: [
+        sh,
+        meson.source_root() / 'meson' / 'part' / 'exports' / 'copy-export.sh',
+    ] + [
+        'config', config_mk, 'config.mk',
+        'config', config_sh, 'config.sh',
+    ] + exported_devel_files
+)
Index: uspace/lib/c/meson.build
===================================================================
--- uspace/lib/c/meson.build	(revision de96d3bfc2010ce18fdf8d42328d4c461d7ca3f2)
+++ uspace/lib/c/meson.build	(revision 00e62883ce36dafecb81ee65875c0b6a4529130b)
@@ -53,4 +53,5 @@
 	_sdir = meson.current_source_dir() / idir
 	uspace_lib_devel_install_script_text += 'cp -R -L -T "@0@" "${DESTDIR}include/libc"'.format(_sdir)
+	exported_devel_files += ['include', _sdir, 'libc']
 endforeach
 
Index: uspace/lib/meson.build
===================================================================
--- uspace/lib/meson.build	(revision de96d3bfc2010ce18fdf8d42328d4c461d7ca3f2)
+++ uspace/lib/meson.build	(revision 00e62883ce36dafecb81ee65875c0b6a4529130b)
@@ -180,9 +180,11 @@
 		if run_command('[', '-d', incdir, ']').returncode() == 0
 			includes += include_directories(incdir)
+			_sdir = meson.current_source_dir() / l / 'include'
 
 			if installed_libs.contains(l)
-				_sdir = meson.current_source_dir() / l / 'include'
 				uspace_lib_devel_install_script_text += 'cp -R -L -T "@0@" "${DESTDIR}include/lib@1@"'.format(_sdir, l)
 			endif
+
+			exported_devel_files += ['include', _sdir, 'lib' + l]
 		else
 			includes += include_directories(l)
@@ -293,4 +295,6 @@
 			install_deps += [ _static_lib ]
 		endif
+
+		exported_devel_files += ['staticlib', _static_lib, 'lib' + l + '.a']
 
 		_static_dep = declare_dependency(
Index: uspace/lib/posix/meson.build
===================================================================
--- uspace/lib/posix/meson.build	(revision de96d3bfc2010ce18fdf8d42328d4c461d7ca3f2)
+++ uspace/lib/posix/meson.build	(revision 00e62883ce36dafecb81ee65875c0b6a4529130b)
@@ -67,2 +67,5 @@
 uspace_lib_devel_install_script_text += 'cp -R -L -T "@0@" "${DESTDIR}include/libposix"'.format(_sdir)
 uspace_lib_devel_install_script_text += 'ln -s -r "${DESTDIR}include/libc" "${DESTDIR}/include/common"'
+
+exported_devel_files += [ 'include', meson.current_source_dir() / 'include' / 'posix', 'libposix' ]
+exported_devel_files += [ 'includesymlink', 'libc', 'libposix' ]
